<?php


/**
 * Class Points
 *
 * @version 2.5.1
 */
class BfwPoints
{

public $conversion = 1; // 1point = 1rub


    /**
     * Склонение существительных после числительных.
     * @param string $value Значение
     * @param array $words Массив вариантов, например: array('товар', 'товара', 'товаров')
     * @param bool $show Включает значение $value в результирующею строку
     * @return string
     * @version 2.10.1
     */
    public static function pointsLabel( int $points, $show = true ): string
    {
        $value = get_option( 'bonus_option_name' );

        $label_point = $value['label_point'] ?? __( 'Point', 'bonus-for-woo' );
        $label_point_two = $value['label_point_two'] ?? __( 'Points', 'bonus-for-woo' );
        $label_points = $value['label_points'] ?? __( 'Points', 'bonus-for-woo' );

        $words = array($label_point, $label_point_two, $label_points);


        $num = $points % 100;
        if ($num > 19) {
            $num = $num % 10;
        }

        $out = ($show) ?  $points . ' ' : '';
        switch ($num) {
            case 1:  $out = $words[0]; break;
            case 2:
            case 3:
            case 4:  $out = $words[1]; break;
            default: $out = $words[2]; break;
        }

        return $out;


    }

    /*
     * Данное решение для тех параметров где используется перед числов предлог "до" например "до 101 балла"
     * */
    public static function pointsLabelUp( int $points, $show = true ): string
    {

        $value = get_option( 'bonus_option_name' );

        $label_point = $value['label_point'] ?? __( 'Point', 'bonus-for-woo' );
        $label_point_two = $value['label_point_two'] ?? __( 'Points', 'bonus-for-woo' );
        $label_points = $value['label_points'] ?? __( 'Points', 'bonus-for-woo' );

        $words = array($label_point_two, $label_points, $label_points);


        $num = $points % 100;
        if ($num > 19) {
            $num = $num % 10;
        }

        $out = ($show) ?  $points . ' ' : '';
        switch ($num) {
            case 1:  $out = $words[0]; break;
            case 2:
            case 3:
            case 4:  $out = $words[1]; break;
            default: $out = $words[2]; break;
        }

        return $out;


    }

    /**
     * Возвращает количество бонусных баллов пользователя
     * @param int $userId
     * @return integer
     * @version 2.5.1
     */
    public static function getPoints(int $userId): int
    {
       $points = get_user_meta($userId, 'computy_point', true) ?? 0;
       return round((int)$points);
    }


    /**
     * Возвращает баллы пользователя, которые он хочет списать
     * @param int $userId
     * @return int
     * @version 2.5.1
     */
    public static function getFastPoints(int $userId): int
    {
        $points = get_user_meta($userId, 'computy_fast_point', true) ?? 0;
        return round((int)$points);
    }


    /**
     * Обновление бонусных баллов
     * @param int $userId
     * @param int $newBalls
     * @version 2.5.1
     */
    public static function updatePoints(int $userId, int $newBalls){
        $newBalls = round($newBalls);
        update_user_meta($userId, 'computy_point', $newBalls);
    }

    /**
     * @param int $userId
     * @param int $newballs
     * @version 2.5.1
     */
    public static function updateFastPoints(int $userId, int $newballs){
        $newballs = round($newballs);
        update_user_meta($userId, 'computy_fast_point', $newballs);
    }

}