<?php

/**
 * Class BfwAdmin
 */
class BfwAdmin {

	public static function init() {
        /* инициализируем меню в админке*/
		add_action( 'admin_menu', array( 'BfwAdmin', 'add_admin_menu' ));
        /*Загружаем скрипты и стили*/
		add_action( 'admin_enqueue_scripts', array( 'BfwAdmin', 'load_scripts' ));
        /*Вывод настроек в меню*/
		add_action( 'admin_init', array( 'BfwAdmin', 'plugin_settings' ));

        /*------------добавление поля в профиле клиента для администратора------------*/
        add_action('show_user_profile', array( 'BfwAdmin', 'bfwoo_add_bonus_in_user_profile' ));
        add_action('edit_user_profile', array( 'BfwAdmin', 'bfwoo_add_bonus_in_user_profile' ));

        /*----добавление поля на странице wp-admin/users.php----*/
        add_filter('manage_users_sortable_columns',  array( 'BfwAdmin', 'bfwoo_sortable_cake_column' ) , 10, 1);
        /* orderby*/
        add_action('pre_get_users',array( 'BfwAdmin', 'bfwoo_action_pre_get_users'), 10, 1);
        add_filter('manage_users_columns', array( 'BfwAdmin', 'bfwoo_add_new_user_column_bonus'));
        add_filter('manage_users_custom_column', array( 'BfwAdmin','bfwoo_add_new_user_column_content'), 10, 3);

        /* Сохранение изменений в профиле клиента*/
        add_action('personal_options_update', array( 'BfwAdmin', 'bfwoo_computy_input_points_add'));
        add_action('edit_user_profile_update', array( 'BfwAdmin', 'bfwoo_computy_input_points_add'));

        add_action('woocommerce_screen_ids', array('BfwAdmin', 'set_screen_id'));


    }



    public static function set_screen_id( $screen ){
        $screen[] = 'woocommerce_page_bonus_for_woo-plugin-options';
        return $screen;
    }
    /*------------добавление поля в профиле клиента для администратора------------*/
    public static function bfwoo_add_bonus_in_user_profile($user)
    {

        ?>
        <hr>
        <div class="user_profile_bfw">
            <h2><?php echo __('User bonus points', 'bonus-for-woo');  ?></h2>

            <?php
            /*Обработчик запроса удаления записи истории начисления баллов*/
            if (isset($_POST['bfw_delete_post_history_points'])) {
                (new BfwHistory)->deleteHistoryId($_POST['bfw_delete_post_history_points']);
 echo '<div id="message" class="notice notice-warning is-dismissible">
	<p>' . __('deleted', 'bonus-for-woo') . '.</p></div>';
            }
            /*Обработчик запроса удаления записи истории начисления баллов*/

            /*Обработчик запроса удаления всей истории начисления баллов*/
            if (isset($_GET['bfw_delete_all_post_history_points'])) {
                $delete_history_points = sanitize_text_field($_GET['bfw_delete_all_post_history_points']);
                (new BfwHistory)->clearAllHistoryUser($delete_history_points);


                echo '<div id="message" class="notice notice-warning is-dismissible">
	<p>' . __('Cleared', 'bonus-for-woo') . '.</p>
</div>';
            }
            /*Обработчик запроса удаления всей истории начисления баллов*/



            $pro = get_option('bonus-for-woo-pro');
            if ($pro == 'active') { ?>

                <i style="color: #005ac9"><?php echo __('You can change the number of bonus points.', 'bonus-for-woo'); ?>
                </i>
                <p><b><?php echo __('Total bonus points', 'bonus-for-woo'); ?>:</b> <?php

                    $balluser =(new BfwPoints)->getPoints($user->ID);
                    echo  $balluser;
                    ?></p>

                <p><?php echo __('Сhange bonus points', 'bonus-for-woo'); ?>
                    <input type="number" name="computy_input_points" value="<?php echo $balluser; ?>" class="regular-text"/></p>
                <p> <textarea style="width: 100%;height: 100px;" name="prichinaizmeneniya" placeholder="<?php echo __('The reason for the change in points. It will be displayed in the client\'s accrual history.','bonus-for-woo');?>"></textarea></p>
                <p> <input type="submit" name="submit" id="submit" class="button button-primary"
                           value="<?php echo __('Сhange', 'bonus-for-woo'); ?>"></p>

            <?php } else { ?>
                <i style="color: #005ac9"><?php echo __('You cannot remove bonus points, but you can add them. Just enter the number of points you want to add.',
                        'bonus-for-woo'); ?>
                </i>
                <p><b><?php echo __('Total bonus points', 'bonus-for-woo'); ?>:</b> <?php
                    $balluser = (new BfwPoints)->getPoints($user->ID);
                    echo esc_attr($balluser);
                    ?></p>

                <p><?php echo __('Add bonus points', 'bonus-for-woo'); ?>
                    <input type="number" name="computy_input_points" value="0" class="regular-text"/>
                <p> <textarea style="width: 100%;height: 100px;" name="prichinaizmeneniya" placeholder="<?php echo __('The reason for the change in points. It will be displayed in the client\'s accrual history.','bonus-for-woo');?>"></textarea></p>
                <input type="submit" name="submit" id="submit" class="button button-primary"
                       value="<?php echo __('Add', 'bonus-for-woo'); ?>"></p>
            <?php } ?>



            <?php
            /*история начислений баллов клиента*/
            (new BfwHistory)->getHistory($user->ID);



            $val = get_option('bonus_option_name');
            $referalwork = isset( $val['referal-system'] ) ? intval( $val['referal-system'] ) : 0;

            /*если включена реферальная система*/
            if($referalwork==1) {?>
                <h3><?php  echo __('Referral system', 'bonus-for-woo'); ?></h3>
                <?php
                $get_referral        = get_user_meta( $user->ID, 'bfw_points_referral', true );
                $get_referral_invite = get_user_meta( $user->ID, 'bfw_points_referral_invite', true );
                /*сколько людей пригласил*/
                $argsa['meta_query'] = array(
                    array(
                        'key' => 'bfw_points_referral_invite',
                        'value' => trim($user->ID),
                        'compare' => '==',
                    ),
                );
                $refere_data = get_users($argsa);
                echo __('Referral link', 'bonus-for-woo').': <code>'.esc_url(site_url() . '?bfwkey=' . $get_referral).'</code><br>';
                if($get_referral_invite==0 OR $get_referral_invite==''){
                    echo '';
                }else{

                    $user_info = get_userdata($get_referral_invite);

                    echo   __('Invited by user', 'bonus-for-woo').': <a href="/wp-admin/user-edit.php?user_id='.$get_referral_invite.'" >'.$user_info->user_login.'('.$user_info->first_name.' '.$user_info->last_name.')</a><br>';
                }

                echo  __('Invited', 'bonus-for-woo').' '.count($refere_data).' '.__('people', 'bonus-for-woo');
            }?>


        </div>
        <hr>
        <?php
    }

    public static function bfwoo_action_pre_get_users($query)
    {
        if (!is_admin()) {
            return;
        }
        $orderby = $query->get('orderby');
        if ($orderby == __('Bonus points', 'bonus-for-woo')) {
            $query->set('orderby', 'meta_value_num');
            $query->set('meta_key', 'computy_point');
        }
    }


    public static function bfwoo_add_new_user_column_bonus($columns)
    {
        $columns['computy_point'] = __('Bonus points', 'bonus-for-woo');
        return $columns;
    }


    public static function bfwoo_add_new_user_column_content($content, $column, $user_id)
    {

        if ('computy_point' === $column) {
            $content = (new BfwPoints)->getPoints($user_id);
        }
        return $content;
    }


    public static function bfwoo_computy_input_points_add($user_id)
    {
        $pro = get_option('bonus-for-woo-pro');
        if ($pro == 'active') {
            $addball = intval(sanitize_text_field($_POST['computy_input_points']));
            $prichina = sanitize_text_field($_POST['prichinaizmeneniya']);
            if($prichina ==''){$prichina='Не указано.';}
            $oldpoint = (new BfwPoints)->getPoints($user_id);

            if($addball>$oldpoint){
                $naskoko =  $addball- $oldpoint;

                /*Записываем в историю*/
                (new BfwHistory)->add_history($user_id,'+',$naskoko,'0',$prichina);
                /*Записываем в историю*/

                $val = get_option('bonus_option_name');
                 $title_email = $val['email-change-admin-title'] ?? __('Bonus points have been added to you!', 'bonus-for-woo');

                $user = get_userdata($user_id);
               /*шаблонизатор письма*/

                    $text_email = $val['email-change-admin-text'] ?? '';

                $get_referral = get_user_meta( $user_id, 'bfw_points_referral', true );
                $text_email_array = array('[referral-link]'=> esc_url(site_url().'?bfwkey='. $get_referral),'[user]'=>$user->display_name,'[points]'=>$naskoko,'[total]'=>$addball,'[cause]'=>$prichina);
                $message_email = (new BfwEmail)->template($text_email,$text_email_array);
                /*шаблонизатор письма*/

                /*отправляем email клиенту*/
                if(isset($val['email-change-admin'])){
                    if($val['email-change-admin']=='1') {
                        (new BfwEmail)->getMail($user_id, '', $title_email, $message_email);
                    }}
                /*отправляем email клиенту*/
            }elseif ($addball<$oldpoint){
                $naskoko =  $oldpoint- $addball;
                $symbol = '-';
                /*Записываем в историю*/
                (new BfwHistory)->add_history($user_id,'-',$naskoko,'0',$prichina);
                /*Записываем в историю*/

                $val = get_option('bonus_option_name');
                $title_email = $val['email-change-admin-title-spisanie'] ?? __('Writing off bonus points', 'bonus-for-woo');

                $user = get_userdata($user_id);
                /*шаблонизатор письма*/

               $text_email = $val['email-change-admin-text-spisanie'] ?? '';

                $get_referral = get_user_meta( $user_id, 'bfw_points_referral', true );
                $text_email_array = array('[referral-link]'=> esc_url(site_url().'?bfwkey='. $get_referral),'[user]'=>$user->display_name,'[points]'=>$naskoko,'[total]'=>$addball,'[cause]'=>$prichina);
                $message_email = (new BfwEmail)->template($text_email,$text_email_array);
                /*шаблонизатор письма*/

                /*отправляем email клиенту*/
                if(isset($val['email-change-admin'])){
                    if($val['email-change-admin']=='1') {
                        (new BfwEmail)->getMail($user_id, '', $title_email, $message_email);
                    }}
                /*отправляем email клиенту*/
            }




            (new BfwPoints)->updatePoints($user_id,$addball);

        } else {
            $balluser = (new BfwPoints)->getPoints($user_id);
            if($_POST['computy_input_points']>0){

                $addball_nopro = sanitize_text_field($_POST['computy_input_points']);
                $addball =  $addball_nopro  + $balluser;
                $prichina = sanitize_text_field($_POST['prichinaizmeneniya']);
                /*Записываем в историю*/
                (new BfwHistory)->add_history($user_id,'+',$addball_nopro,'0',$prichina);
                /*Записываем в историю*/

                /*отправляем email клиенту*/
                $user = get_userdata($user_id);
                $title_email = __('Bonus points have been added to you!', 'bonus-for-woo');
                $info_email = sprintf(__('%s bonus points have been added to you.', 'bonus-for-woo'), sanitize_text_field($_POST['computy_input_points']));

                $message_email='<p>'.$info_email.'</p>';
                $message_email.='<p>'.__('Cause', 'bonus-for-woo').': '.$prichina.'</p>';
                $message_email.='<p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>'.$addball.' '.__('points', 'bonus-for-woo').'</b></p>';
                $val = get_option( 'bonus_option_name' );
                if(isset($val['email-change-admin'])){
                    if($val['email-change-admin']=='1') {
                        (new BfwEmail)->getMail($user_id, '', $title_email, $message_email);
                    }}
                /*отправляем email клиенту*/


                (new BfwPoints)->updatePoints($user_id,$addball);
            }

        }

    }

    /*----добавление поля на странице wp-admin/users.php----*/
    public static function bfwoo_sortable_cake_column($columns)
    {
        $columns['computy_point'] = __('Bonus points', 'bonus-for-woo');
        return $columns;
    }

    public static function bonuses_link( $menu_links ){
        $menu_links = array_slice( $menu_links, 0, 5, true ) + array( 'bonuses' => __( 'My bonuses', 'bonus-for-woo' ) ) + array_slice( $menu_links, 5, NULL, true );
        $menu_links[ 'bonuses' ] = __( 'My bonuses', 'bonus-for-woo' );
        return $menu_links;
    }


    public static function bonuses_add_endpoint() {
        add_rewrite_endpoint( 'bonuses', EP_PAGES );
    }

    /* инициализируем меню в админке*/
	public static function add_admin_menu() {
        $menu_title =  __('Bonus for Woo', 'bonus-for-woo');
        add_submenu_page( 'woocommerce',__( 'Bonus for Woo', 'bonus-for-woo'), $menu_title, 'manage_woocommerce', 'bonus_for_woo-plugin-options', array( 'BfwAdmin', 'bonus_plugin_options'  ) );

        $munu_list_history =__('Bonus points history', 'bonus-for-woo');
        $munu_list_history_title =__('History of bonus points for all customers', 'bonus-for-woo');

       // Добавляем в меню историю всех начислений клиентов
        add_submenu_page( 'users.php', $munu_list_history_title, $munu_list_history, 'manage_options', 'bonus-for-woo/index/list_history.php', '' , 1 );
    }




	public static function load_scripts() {
		wp_register_style( 'bonus-for-woo-computy-style-admin', BONUS_COMPUTY_PLUGIN_URL . '_inc/bonus-for-woo-style-admin.css', array(), BONUS_COMPUTY_VERSION );
        wp_enqueue_style( 'bonus-for-woo-computy-style-admin' );

        wp_register_style( 'slimselectcss', BONUS_COMPUTY_PLUGIN_URL . '_inc/slimselect.min.css', array(), BONUS_COMPUTY_VERSION );
        wp_enqueue_style( 'slimselectcss' );

        wp_register_script('bonus-computy-script-admin', BONUS_COMPUTY_PLUGIN_URL . '_inc/bonus-computy-script-admin.js',
            array('jquery'), null, true);
        wp_enqueue_script('bonus-computy-script-admin');

        wp_register_script('slimselect', BONUS_COMPUTY_PLUGIN_URL . '_inc/slimselect.min.js',
            array('jquery'), null, true);
        wp_enqueue_script('slimselect');
    }

    /*Вывод настроек в меню*/
	public static function plugin_settings() {
		register_setting( 'option_group_bonus', 'bonus_option_name', 'sanitize_callback' );
        $trans1  = __( 'Plugin settings', 'bonus-for-woo' );
        $trans2  = __( 'Number of bonus points for a product review', 'bonus-for-woo' ).wc_help_tip(__( '* If the value is greater than 0, all reviews will have to be manually approved.', 'bonus-for-woo' ).'<br>'.__( '* Accrued only if the customer bought this product.', 'bonus-for-woo' ), false);
         $trans12 = __( 'Should you display the points that the customer will receive on the product page?', 'bonus-for-woo' );

        $trans14  = __( 'Writing off points in ordering', 'bonus-for-woo' );
        $trans15  = __( 'Hide deduction of points for sale items?', 'bonus-for-woo' );
        $trans166  = '<h2>'.__( 'Pro settings', 'bonus-for-woo' ).'</h2>';
        $trans16  = __( 'Percentage of the order amount that can be spent by the client in points.', 'bonus-for-woo' );
        $trans17  = __( 'Exclude product categories that cannot be purchased with cashback points.', 'bonus-for-woo' );
        $trans18  = __( 'Exclude products that cannot be purchased with cashback points.', 'bonus-for-woo' );
        $trans19  = __( 'Points for registration', 'bonus-for-woo' );
        $trans20  = __( 'Accrue cashback on excluded products and categories?', 'bonus-for-woo' );
        $trans21  = __( 'Referral system', 'bonus-for-woo' );
        $trans21qty  = __( 'Clear points that the customer wants to deduct when the number of items in the cart changes', 'bonus-for-woo' );
        $trans22  = __( 'Exclude roles from the bonus system', 'bonus-for-woo' );
        $trans23  = __( 'Don\'t spend points if a coupon is applied?', 'bonus-for-woo' );
        $trans24  = __( 'Remove cashback for delivery?', 'bonus-for-woo' );
        $trans25  = __( 'The minimum order amount to use points.', 'bonus-for-woo' );
        $trans26  = __( 'The percentage of points accrued from the referral\'s order.', 'bonus-for-woo' );
        $trans27 = __( 'Earn points only for the first referral order?', 'bonus-for-woo' );
        $trans28 = __( 'Hide customer points history?', 'bonus-for-woo' );
        $trans12a = __( 'Show points that will be returned to the customer in the cart and checkout?', 'bonus-for-woo' );
        $trans29 = __( 'The Sum of orders after which the referral system will become available to the client.', 'bonus-for-woo' );
        $trans_soc = __( 'Social links for the referral system', 'bonus-for-woo' ).wc_help_tip(__( 'The icons will appear on the user\'s account page.', 'bonus-for-woo' ), false);
        $trans_soc2 = __( 'Show social media links on product page?', 'bonus-for-woo' );
        $transclear  = __( 'Remove plugin traces upon activation.', 'bonus-for-woo' );
        $trans30  = __( 'The order of the "My bonuses" menu item in the client account.', 'bonus-for-woo' );
        $trans_inactive = __( 'Removing bonus points for inactivity', 'bonus-for-woo' );
        register_setting( 'option_trans_group_bonus', 'bonus_option_name', 'sanitize_callback' );
        add_settings_section( 'bonus_section_id', $trans1, '', 'primer_page_bonus' );
       //позднее включим когда время будет все доделать
        add_settings_field( 'bonus_field0', __( 'Points Label', 'bonus-for-woo' ).wc_help_tip(__( 'First field singular, second plural.', 'bonus-for-woo' )), array( 'BfwAdmin', 'name_points' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field1', $trans2, array( 'BfwAdmin', 'fill_primer_field1' ), 'primer_page_bonus', 'bonus_section_id' );



        add_settings_field( 'my_checkbox_field', $trans12, array( 'BfwAdmin', 'fill_primer_field12' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'my_checkbox_field12a', $trans12a, array( 'BfwAdmin', 'fill_primer_field12a' ), 'primer_page_bonus', 'bonus_section_id' );

        add_settings_field( 'my_checkbox_field14', $trans14, array( 'BfwAdmin', 'fill_primer_field14' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'my_checkbox_field15', $trans15, array( 'BfwAdmin', 'fill_primer_field15' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'my_checkbox_field23', $trans23, array( 'BfwAdmin', 'fill_primer_field23' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'my_checkbox_field24', $trans24, array( 'BfwAdmin', 'fill_primer_field24' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'my_checkbox_field28', $trans28, array( 'BfwAdmin', 'fill_primer_field28' ), 'primer_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field30', $trans30, array( 'BfwAdmin', 'fill_primer_field30' ), 'primer_page_bonus', 'bonus_section_id' );


        $pro = get_option( 'bonus-for-woo-pro' ); if($pro == 'active'){
            add_settings_field( 'my_checkbox_field166', $trans166, array( 'BfwAdmin', 'fill_primer_field166' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field16', $trans16, array( 'BfwAdmin', 'fill_primer_field16' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field17', $trans17, array( 'BfwAdmin', 'fill_primer_field17' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field18', $trans18, array( 'BfwAdmin', 'fill_primer_field18' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field20', $trans20, array( 'BfwAdmin', 'fill_primer_field20' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field19', $trans19, array( 'BfwAdmin', 'fill_primer_field19' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field122', $trans22, array( 'BfwAdmin', 'fill_primer_field22' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field125', $trans25, array( 'BfwAdmin', 'fill_primer_field25' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_checkbox_field21qty', $trans21qty, array( 'BfwAdmin', 'fill_primer_field21qty' ), 'primer_page_bonus', 'bonus_section_id' );
            add_settings_field( 'my_input_inactive', $trans_inactive, array( 'BfwAdmin', 'fill_inactive' ), 'primer_page_bonus', 'bonus_section_id' );



            add_settings_field( 'my_checkbox_field21', $trans21, array( 'BfwAdmin', 'fill_primer_field21' ), 'primer_page_bonus', 'bonus_section_id' );
            $ref = get_option( 'bonus_option_name' ); if(isset($ref['referal-system'])){
                if($ref['referal-system']=='1'){
                    add_settings_field( 'my_checkbox_field27', $trans27, array( 'BfwAdmin', 'fill_primer_field27' ), 'primer_page_bonus', 'bonus_section_id' );
                    add_settings_field('my_checkbox_field26', $trans26, array('BfwAdmin', 'fill_primer_field26'), 'primer_page_bonus', 'bonus_section_id');
                    add_settings_field('my_checkbox_field29', $trans29, array('BfwAdmin', 'fill_primer_field29'), 'primer_page_bonus', 'bonus_section_id');
                    add_settings_field('social_icons', $trans_soc, array('BfwAdmin', 'fill_primer_field_social'), 'primer_page_bonus', 'bonus_section_id');
                    add_settings_field('social_icons2', $trans_soc2, array('BfwAdmin', 'fill_primer_field_social_on_page'), 'primer_page_bonus', 'bonus_section_id');


                }}
        }

        add_settings_field( 'my_checkbox_clear', $transclear, array( 'BfwAdmin', 'fill_primer_clear' ), 'primer_page_bonus', 'bonus_section_id' );


        $trans3  = __( 'The title in the customers account.', 'bonus-for-woo' );
        $trans3h = __( 'Bonus point history heading.', 'bonus-for-woo' );
        $trans4  = __( '"My status" in the customer account.', 'bonus-for-woo' );
        $trans5  = __( '"My cashback percentage" in the customer account.', 'bonus-for-woo' );
        $trans6  = __( '"My bonus points" in the customer account.', 'bonus-for-woo' );
        $trans7  = __( 'Bonus text in the shopping cart.', 'bonus-for-woo' );
        $trans8  = __( '"Use points" text in the shopping cart.', 'bonus-for-woo' );
        $trans9  = __( '"Bonus points" text in the shopping cart.', 'bonus-for-woo' );
        $trans10  = __( '"Remove points" text on button in the shopping cart.', 'bonus-for-woo' );
        $trans11  = __( 'Information about the remaining amount for the transition to another status.', 'bonus-for-woo' );

        $trans13 =__( 'Custom text translation', 'bonus-for-woo' );


        add_settings_section( 'bonus_section_id', __( 'Translate', 'bonus-for-woo' ), '', 'trans_page_bonus' );
        add_settings_field( 'bonus_field2', $trans3, array( 'BfwAdmin', 'fill_primer_field2' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field2h', $trans3h, array( 'BfwAdmin', 'fill_primer_field2h' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field4', $trans4, array( 'BfwAdmin', 'fill_primer_field4' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field5', $trans5, array( 'BfwAdmin', 'fill_primer_field5' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field6', $trans6, array( 'BfwAdmin', 'fill_primer_field6' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field11', $trans11, array( 'BfwAdmin', 'fill_primer_field11' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field7', $trans7, array( 'BfwAdmin', 'fill_primer_field7' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field8', $trans8, array( 'BfwAdmin', 'fill_primer_field8' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field9', $trans9, array( 'BfwAdmin', 'fill_primer_field9' ), 'trans_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field10', $trans10, array( 'BfwAdmin', 'fill_primer_field10' ), 'trans_page_bonus', 'bonus_section_id' );
        /*add_settings_field( 'bonus_field10a', __('Translations for the history of bonus accrual'), array( 'Bonus_Admin', 'fill_primer_field166' ), 'trans_page_bonus', 'bonus_section_id' );*/



        /*emails*/
        $trans_e = __('Email settings', 'bonus-for-woo');
        $trans_e1 = __('Headings and styling:','bonus-for-woo');
        $trans_e2 = __('Changes to points by the administrator','bonus-for-woo');
        $trans_e3 = __('When registering','bonus-for-woo');
        $trans_e4 = __('When the order is confirmed','bonus-for-woo');
        $trans_e5 = __('When processing an order by an administrator(paid, returned)','bonus-for-woo');
        $trans_e6 = __('Product Review Notice(approval, rejection)','bonus-for-woo');
        $trans_e7 = __('When the status changes','bonus-for-woo');

        register_setting( 'option_mail_group_bonus', 'bonus_option_name', 'sanitize_callback' );
        add_settings_section( 'bonus_section_id', $trans_e, '', 'mail_page_bonus' );
        add_settings_field( 'bonus_field_email_1', $trans_e1, array( 'BfwAdmin', 'fill_email_1' ), 'mail_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field_email_2', $trans_e2, array( 'BfwAdmin', 'fill_email_2' ), 'mail_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field_email_2t', __('Email template when points are added by admin','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Number of points','bonus-for-woo').'<br>[cause]-'.__('Cause','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_2_template' ), 'mail_page_bonus', 'bonus_section_id' );
        if($pro == 'active'){
            add_settings_field( 'bonus_field_email_2ts', __('Email template when writing off points by admin','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Number of points','bonus-for-woo').'<br>[cause]-'.__('Cause','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_2_template2' ), 'mail_page_bonus', 'bonus_section_id' );
        }

        if($pro == 'active'){
            add_settings_field( 'bonus_field_email_3', $trans_e3, array( 'BfwAdmin', 'fill_email_3' ), 'mail_page_bonus', 'bonus_section_id' );
            add_settings_field( 'bonus_field_email_3t', __('New user registration email template','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Number of points','bonus-for-woo').'<br>[cause]-'.__('Cause','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_3_template' ), 'mail_page_bonus', 'bonus_section_id' );
        }
        add_settings_field( 'bonus_field_email_4', $trans_e4, array( 'BfwAdmin', 'fill_email_4' ), 'mail_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field_email_4t', __('Template of the letter when the customer confirmed the order','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br>[order]-'.__('Order','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Number of points','bonus-for-woo').'<br>[cause]-'.__('Cause','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_4_template' ), 'mail_page_bonus', 'bonus_section_id' );

        add_settings_field( 'bonus_field_email_5', $trans_e5, array( 'BfwAdmin', 'fill_email_5' ), 'mail_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field_email_5t', __('Email template, when order status is complete','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Points amount','bonus-for-woo').'<br>[order]-'.__('Order','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_5_template' ), 'mail_page_bonus', 'bonus_section_id' );
         add_settings_field( 'bonus_field_email_5tr', __('Email template when order status is complete from referral.','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Points amount','bonus-for-woo').'<br>[cause]-'.__('Cause','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_5_template_ref' ), 'mail_page_bonus', 'bonus_section_id' );

        add_settings_field( 'bonus_field_email_5t2', __('Email template, when order status is returned','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[cashback]-'.__('Cashback amount','bonus-for-woo').'<br>[points]-'.__('Number of points','bonus-for-woo').'<br>[order]-'.__('Order','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_5_template2' ), 'mail_page_bonus', 'bonus_section_id' );

        add_settings_field( 'bonus_field_email_6', $trans_e6, array( 'BfwAdmin', 'fill_email_6' ), 'mail_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field_email_6t', __('Email template when leaving a product review','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[total]-'.__('Total points for the client','bonus-for-woo').'<br>[points]-'.__('Number of points','bonus-for-woo').'<br>[cause]-'.__('Сause','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_6_template' ), 'mail_page_bonus', 'bonus_section_id' );


        add_settings_field( 'bonus_field_email_7', $trans_e7, array( 'BfwAdmin', 'fill_email_7' ), 'mail_page_bonus', 'bonus_section_id' );
        add_settings_field( 'bonus_field_email_7t', __('Template for a letter when a client status changes','bonus-for-woo').'<br>'.__('Use shortcodes:','bonus-for-woo').'<br> [user]-'.__('Client name','bonus-for-woo').'<br>[role]-'.__('User status','bonus-for-woo').'<br>[cashback]-'.__('Cashback percentage','bonus-for-woo').'<br>[referral-link]-'.__('Referral link','bonus-for-woo'), array( 'BfwAdmin', 'fill_email_7_template' ), 'mail_page_bonus', 'bonus_section_id' );


        /*emails*/
    }


    ## Социальные ссылки для рефералов
    public static function fill_primer_field_social() {
        $val = get_option( 'bonus_option_name' );
        $checkedvk = isset($val['ref-social-vk']) ? "checked" : "";
        $checkedfb = isset($val['ref-social-fb']) ? "checked" : "";
        $checkedtw = isset($val['ref-social-tw']) ? "checked" : "";
        $checkedtg = isset($val['ref-social-tg']) ? "checked" : "";
        $checkedwhatsapp = isset($val['ref-social-whatsapp']) ? "checked" : "";
        $checkedviber = isset($val['ref-social-viber']) ? "checked" : "";
        ?>
        <input id="ref-social-vk" name="bonus_option_name[ref-social-vk]" type="checkbox" value="1" <?php echo $checkedvk; ?>>
        <label for="ref-social-vk" class="ref-social ref-social-vk">VK</label>

        <input id="ref-social-fb" name="bonus_option_name[ref-social-fb]" type="checkbox" value="1" <?php echo $checkedfb; ?>>
        <label for="ref-social-fb" class="ref-social ref-social-fb">FACEBOOK</label>

        <input id="ref-social-tw" name="bonus_option_name[ref-social-tw]" type="checkbox" value="1" <?php echo $checkedtw; ?>>
        <label for="ref-social-tw" class="ref-social ref-social-tw">TWITTER</label>

        <input id="ref-social-tg" name="bonus_option_name[ref-social-tg]" type="checkbox" value="1" <?php echo $checkedtg; ?>>
        <label for="ref-social-tg" class="ref-social ref-social-tg">TELEGRAM</label>

        <input id="ref-social-whatsapp" name="bonus_option_name[ref-social-whatsapp]" type="checkbox" value="1" <?php echo $checkedwhatsapp; ?>>
        <label for="ref-social-whatsapp" class="ref-social ref-social-whatsapp">WHATSAPP</label>

        <input id="ref-social-viber" name="bonus_option_name[ref-social-viber]" type="checkbox" value="1" <?php echo $checkedviber; ?>>
        <label for="ref-social-viber" class="ref-social ref-social-viber">VIBER</label>
    <?php }

    ## Социальные ссылки для рефералов на старнице продукта
    public static function fill_primer_field_social_on_page(){
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['ref-links-on-single-page']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[ref-links-on-single-page]" type="checkbox" value="1" <?php echo $checked; ?>>

    <?php }

## Заполняем опцию fill_email_1
    public static function fill_email_1() {?>
      <p><?php echo __('In the <a href="/wp-admin/admin.php?page=wc-settings&tab=email" target="_blank">settings woocommerce</a>, it is indicated from whom the letter will be sent. If not specified, the general settings <a href="/wp-admin/options-general.php" target="_blank">from the page</a> will be used. All email design in settings Woocommerce. The notification text is generated automatically.','bonus-for-woo'); ?></p>
    <?php }

    ## отправлять ли письмо при изменениях баллов админом
    public static function fill_email_2() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['email-change-admin']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[email-change-admin]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

    ## Заполняем шаблон при начеслении баллов админом
    public static function fill_email_2_template() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-change-admin-title'] ?? __('Bonus points have been added to you!', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('%s bonus points have been added to you.', 'bonus-for-woo'), '[points]').'</p>
      <p>'.__('Cause', 'bonus-for-woo').': [cause]</p> 
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Bonus points have been added to you!', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-change-admin-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-change-admin-text'] ?? $text_email;
        $editor_id = 'email-change-admin-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-change-admin-text]' );
        wp_editor( $content, $editor_id, $settings );

    }

    ## Заполняем шаблон при списании баллов админом
    public static function fill_email_2_template2() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-change-admin-title-spisanie'] ?? __('Writing off bonus points', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('%s bonus points were deducted from you.', 'bonus-for-woo'), '[points]').'</p>
      <p>'.__('Cause', 'bonus-for-woo').': [cause]</p> 
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Writing off bonus points', 'bonus-for-woo');?>" type="text" name="bonus_option_name[email-change-admin-title-spisanie]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-change-admin-text-spisanie'] ?? $text_email;
        $editor_id = 'email-change-admin-text-spisanie';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-change-admin-text-spisanie]' );
        wp_editor( $content, $editor_id, $settings );

    }

    ## отправлять ли письмо о начислении баллов за регистрацию
    public static function fill_email_3() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['email-when-register']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[email-when-register]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

    ## Заполняем шаблон письма при регистраци
    public static function fill_email_3_template(){
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-register-title'] ?? __('Bonus points have been added to you!', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('%s bonus points have been added to you.', 'bonus-for-woo'), '[points]').'</p>
      <p>'.__('Cause', 'bonus-for-woo').': [cause]</p> 
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Bonus points have been added to you!', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-register-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-register-text'] ?? $text_email;
        $editor_id = 'email-when-register-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-register-text]' );
        wp_editor( $content, $editor_id, $settings );

    }

    ## отправлять ли письмо о начислении баллов когда заказ подтвержден клиентом
    public static function fill_email_4() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['email-when-order-confirm']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[email-when-order-confirm]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

## Заполняем шаблон письма когда заказ подтвержден клиентом
    public static function fill_email_4_template(){
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-order-confirm-title'] ?? __('Writing off bonus points', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('You used %s bonus points to pay for order number %s.', 'bonus-for-woo'), '[points]','[order]').'</p>
      <p>'.__('Cause', 'bonus-for-woo').': [cause]</p> 
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Bonus points have been added to you!', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-order-confirm-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-order-confirm-text'] ?? $text_email;
        $editor_id = 'email-when-order-confirm-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-order-confirm-text]' );
        wp_editor( $content, $editor_id, $settings );

    }


    ## отправлять ли письмо когда поменялся статус заказа
    public static function fill_email_5() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['email-when-order-change']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[email-when-order-change]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

## Заполняем шаблон при начеслении баллов когда заказ оплачен
    public static function fill_email_5_template() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-order-change-title'] ?? __('Points accrual', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('You have accrued %s bonus points from order number %s.', 'bonus-for-woo'), '[points]','[order]').'</p>
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Bonus points have been added to you!', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-order-change-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-order-change-text'] ?? $text_email;
        $editor_id = 'email-when-order-change-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-order-change-text]' );
        wp_editor( $content, $editor_id, $settings );

    }

## Заполняем шаблон при начеслении баллов когда заказ оплачен рефералом
    public static function fill_email_5_template_ref(){
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-order-change-referal-title'] ?? __('Points accrual', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('You have been credited with %s bonus points.', 'bonus-for-woo'), '[points]').'</p>
      <p>'.__('Cause', 'bonus-for-woo').': [cause]</p>
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Points accrual', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-order-change-referal-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-order-change-referal-text'] ?? $text_email;
        $editor_id = 'email-when-order-change-referal-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-order-change-referal-text]' );
        wp_editor( $content, $editor_id, $settings );
    }

    ## Заполняем шаблон при начеслении баллов когда заказ возвращен
    public static function fill_email_5_template2() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-order-change-title-vozvrat'] ?? __('Refund of bonus points', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('The %s bonus points you earned for order no. %s have been canceled.', 'bonus-for-woo'), '[cashback]','[order]').'</p>
      <p>'.sprintf(__('You have returned %s bonus points for order number %s.', 'bonus-for-woo'), '[points]','[order]').'</p>
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Bonus points have been added to you!', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-order-change-title-vozvrat]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-order-change-text-vozvrat'] ?? $text_email;
        $editor_id = 'email-when-order-change-text-vozvrat';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-order-change-text-vozvrat]' );
        wp_editor( $content, $editor_id, $settings );

    }

    ## Заполняем опцию fill_email_6
    public static function fill_email_6() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['email-when-review']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[email-when-review]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

    ## Заполняем шаблон при начеслении баллов когда одобрен отзыв
    public static function fill_email_6_template() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-review-title'] ?? __('Points accrual', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('You have received %s bonus points for a product review.', 'bonus-for-woo'), '[points]').'</p>
      <p>'.__('Cause', 'bonus-for-woo').': [cause]</p>
      <p>'.__('The sum of your bonus points is now', 'bonus-for-woo').': <b>[total] '.__('points', 'bonus-for-woo').'</b></p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Bonus points have been added to you!', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-review-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-review-text'] ?? $text_email;
        $editor_id = 'email-when-review-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-review-text]' );
        wp_editor( $content, $editor_id, $settings );

    }

    ## Заполняем опцию fill_email_7
    public static function fill_email_7() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['email-when-status-chenge']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[email-when-status-chenge]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

    ## Шаблон письма, когда меняется статус
    public static function fill_email_7_template() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['email-when-status-chenge-title'] ?? __('Changing your status', 'bonus-for-woo');

        $text_email = '<p>'.__('Hello','bonus-for-woo').', [user]</p>
      <p>'.sprintf(__('Now your status is "%s".', 'bonus-for-woo'), '[role]').'</p> 
      <p>'.__('Now the percentage of cashback:', 'bonus-for-woo').' [cashback]%</p>';
        ?>
        <div class="label-input-mail"><?php echo __('Email header','bonus-for-woo'); ?></div>
        <input style="width:100%" placeholder="<?php echo __('Changing your status', 'bonus-for-woo'); ?>" type="text" name="bonus_option_name[email-when-status-chenge-title]" value="<?php echo esc_attr( $value ) ?>" />
        <div class="label-editor-mail"><?php echo __('Letter template','bonus-for-woo'); ?></div>
        <?php
        $content   = $val['email-when-status-chenge-text'] ?? $text_email;
        $editor_id = 'email-when-status-chenge-text';
        $settings  = array( 'media_buttons' => true,'textarea_name' => 'bonus_option_name[email-when-status-chenge-text]' );
        wp_editor( $content, $editor_id, $settings );

    }

    ## Заполняем опцию 166
    public static function fill_primer_field166() {?>
       <hr>
    <?php }

    ## Заполняем опцию 12
    public static function fill_primer_field12() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['bonus-in-price']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[bonus-in-price]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

    ## Заполняем опцию 12а
    public static function fill_primer_field12a() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['cashback-in-cart']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[cashback-in-cart]" type="checkbox" value="1" <?php echo $checked; ?>>
    <?php }

    ## Заполняем опцию 14
    public static function fill_primer_field14() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['spisanie-in-checkout']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[spisanie-in-checkout]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:red">* <?php echo __( 'Uncheck the checkbox if the checkout is in the basket.', 'bonus-for-woo' )?>
             </small>

    <?php }

    ## Заполняем опцию 15
    public static function fill_primer_field15() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['spisanie-onsale']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[spisanie-onsale]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:grey"><?php echo __( '*if all items are in the sale cart', 'bonus-for-woo' )?>
        </small>

    <?php }

    ## Заполняем опцию 16
    public static function fill_primer_field16() {
        $val = get_option( 'bonus_option_name' );
        $val = isset($val['max-percent-bonuses']) ? (int)$val['max-percent-bonuses'] : 100;
        ?>

        <input style="width: 60px" type="number" min="0" max="100"   name="bonus_option_name[max-percent-bonuses]" value="<?php echo esc_attr( $val ) ?>" />
        <small style="color:#999999"><?php echo __( '%', 'bonus-for-woo' )?></small>
    <?php }

    ## Заполняем опцию 17
    public static function fill_primer_field17()
    {
        $val = get_option('bonus_option_name');

        if(empty($val['exclude-category-cashback'])){
            $val['exclude-category-cashback'] = array();
        }
        ?>


        <select multiple="multiple" id="exclude-category" name="bonus_option_name[exclude-category-cashback][]">
            <?php

            $get_categories_product = get_terms("product_cat", [
                "orderby" => "name", // Тип сортировки
                "order" => "ASC", // Направление сортировки
                "hide_empty" => 0, // Скрывать пустые. 1 - да, 0 - нет.
            ]);
            $selected ='';
            foreach ($get_categories_product as $cat_item) {
               $selected = in_array($cat_item->term_id, $val['exclude-category-cashback']) ? ' selected="selected" ' : '';

                echo "<option " . $selected . " value='" . esc_attr($cat_item->term_id) . "'>" . esc_html($cat_item->name) . "</option>";
            }
            ?>
        </select>

        <?php
    }

    ## Заполняем опцию 18
    public static function fill_primer_field18() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['exclude-tovar-cashback'] ?? '';
        ?>
        <input style="width: 250px" placeholder="3124,524,231" type="text" name="bonus_option_name[exclude-tovar-cashback]" value="<?php echo esc_attr( $value ) ?>" />
    <?php
	}

    ## Заполняем опцию 19
    public static function fill_primer_field19() {
        $val = get_option( 'bonus_option_name' );
        $valpr = isset($val['points-for-registration']) ? (int)$val['points-for-registration'] : 100;
        ?>
        <input style="width: 80px" min="0" placeholder="50" type="number" name="bonus_option_name[points-for-registration]" value="<?php echo esc_attr( $valpr ) ?>" />

    <?php

        if(isset($val['referal-system'])){
            if($val['referal-system']=='1'){
                $checkedr = isset($val['register-points-only-referal']) ? "checked" : "";
                ?>
                <input name="bonus_option_name[register-points-only-referal]" type="checkbox" value="1" <?php echo $checkedr; ?>>
                <small style="color:grey">* <?php echo __( 'Add points only to the referral.', 'bonus-for-woo' )?>
                </small>
                <?php
            }}
	}

    ## Заполняем опцию 20
    public static function fill_primer_field20() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['addkeshback-exclude']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[addkeshback-exclude]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:grey">* <?php echo __( 'Yes, accrue', 'bonus-for-woo' )?>
        </small>

    <?php }

    ## очищать баллы, которые хочет списать клиент при изменении количества товаров  корзине
    public static function fill_primer_field21qty() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['clear-fast-bonus-were-qty-cart']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[clear-fast-bonus-were-qty-cart]" type="checkbox" value="1" <?php echo $checked; ?>>

    <?php }

    ## Удаление баллов за бездействие
    public static function fill_inactive() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['day-inactive'] ?? '';
        ?>
        <input style="width: 100px" placeholder="365"  step="1" pattern="\d+" type="number" name="bonus_option_name[day-inactive]" value="<?php echo esc_attr( $value ) ?>" /> <?php echo __( 'days without orders', 'bonus-for-woo' )?>
        <?php
         /* var_dump( get_option( 'cron' ) );*/
    }

    ## реферальная система
    public static function fill_primer_field21() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['referal-system']) ? "checked" : "";
        ?>
        <input id="referal-system" name="bonus_option_name[referal-system]" type="checkbox" value="1" <?php echo $checked; ?>>

    <?php }

    ## начислять баллы только за 1 заказ реферала
    public static function fill_primer_field27() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['first-order-referal']) ? "checked" : "";
        ?>
        <input  name="bonus_option_name[first-order-referal]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:red">* <?php echo __( 'The referral will not receive points from the second order.', 'bonus-for-woo' )?>
        </small>
    <?php }

    ## Заполняем опцию 26
    public static function fill_primer_field26() {
        $val = get_option( 'bonus_option_name' );

        $val = isset($val['referal-cashback']) ? (int)$val['referal-cashback'] : 0;
        ?>

        <input style="width: 60px" placeholder="0" min="0" max="100" type="number" name="bonus_option_name[referal-cashback]" value="<?php echo esc_attr( $val ) ?>" />
        <small style="color:#999999">%</small>
     <?php }

    ## Заполняем опцию 29
    public static function fill_primer_field29() {
        $val = get_option( 'bonus_option_name' );
        $val = isset($val['sum-orders-for-referral']) ? (int)$val['sum-orders-for-referral'] : 0;
        ?>

        <input style="width: 80px" placeholder="0" min="0" type="number" name="bonus_option_name[sum-orders-for-referral]" value="<?php echo esc_attr( $val ) ?>" /> <?php echo get_woocommerce_currency_symbol();?>

    <?php }

    ## Заполняем опцию 24(минимальная сумма за каза)
    public static function fill_primer_field25() {
        $val = get_option( 'bonus_option_name' );
        $valas = isset($val['minimal-amount']) ? (int)$val['minimal-amount'] : 0;
        ?>
        <input style="width: 80px" placeholder="50" min="0" type="number" name="bonus_option_name[minimal-amount]" value="<?php echo esc_attr( $valas ) ?>" /> <?php echo get_woocommerce_currency_symbol();

        $checkedmin = isset($val['minimal-amount-cashback']) ? "checked" : "";

        ?>
        <input name="bonus_option_name[minimal-amount-cashback]" type="checkbox" value="1" <?php echo $checkedmin; ?>>
        <small style="color:grey">* <?php echo __( 'Valid for cashback', 'bonus-for-woo' )?>
        </small>
       <?php
     }

    ## Заполняем опцию 22
    public static function fill_primer_field22() {
        $val = get_option( 'bonus_option_name' );
        if(empty($val['exclude-role'])){
            $val['exclude-role'] = array();
        }
        ?>
        <select  multiple="multiple" id="exclude-role" name="bonus_option_name[exclude-role][]">
            <?php
            foreach ( get_editable_roles()  as $role => $details ) {
                $name = translate_user_role( $details['name'] );
                $selected = in_array( $role , $val['exclude-role']) ? ' selected="selected" ' : '';
if ($role == 'administrator'){
    $selected =  'selected="selected"  data-mandatory="true"';
}
       echo "<option ".$selected." value='" . esc_attr( $role ) . "'>$name</option>";
            }
            ?>
        </select>


    <?php


	}

  //название баллов
    public static function name_points(){
        $value = get_option( 'bonus_option_name' );

        $label_point = $value['label_point'] ?? __( 'Point', 'bonus-for-woo' );
        $label_point_two = $value['label_point_two'] ?? __( 'Points', 'bonus-for-woo' );
        $label_points = $value['label_points'] ?? __( 'Points', 'bonus-for-woo' );
        ?>
        1 <input style="width: 80px" type="text" name="bonus_option_name[label_point]" value="<?php echo esc_attr( $label_point ) ?>" />,
        2 <input style="width: 80px" type="text" name="bonus_option_name[label_point_two]" value="<?php echo esc_attr( $label_point_two ) ?>" />,
       25 <input style="width: 80px" type="text" name="bonus_option_name[label_points]" value="<?php echo esc_attr( $label_points ) ?>" />
        <?php
    }

	## Заполняем опцию 1
	public static function fill_primer_field1() {
		$val = get_option( 'bonus_option_name' );
        $val = isset($val['bonus-for-otziv']) ? (int)$val['bonus-for-otziv'] : 0;
		?>

      <input style="width: 50px" type="number" name="bonus_option_name[bonus-for-otziv]" value="<?php echo esc_attr( $val ) ?>" /> <?php echo (new BfwPoints())->pointsLabel ($val); ?>
 <?php }

    ## Заполняем опцию 30 порядок меню в аккаунте
    public static function fill_primer_field30() {
        $val = get_option( 'bonus_option_name' );
        $val = isset($val['poryadok-in-account']) ? (int)$val['poryadok-in-account'] : 4;
        ?>

        <input style="width: 50px" min="1" max="10" type="number" name="bonus_option_name[poryadok-in-account]" value="<?php echo esc_attr( $val ) ?>" />
    <?php }

    ## опция23
    public static function fill_primer_field23() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['balls-and-coupon']) ? "checked" : "";
        ?>
        <input id="balls-and-coupon" name="bonus_option_name[balls-and-coupon]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:#999999"><?php echo __( 'When the checkbox is selected, the points cannot be spent, but the cashback will be accrued.', 'bonus-for-woo' )?></small>



    <?php }

    ## опция24
    public static function fill_primer_field24() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['cashback-for-shipping']) ? "checked" : "";
        ?>
        <input  name="bonus_option_name[cashback-for-shipping]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:#999999"><?php echo __( 'When the checkbox is checked, cashback for delivery will not be credited.', 'bonus-for-woo' )?></small>



    <?php }



    ## опция fill_primer_clear
    public static function fill_primer_clear() {
        $val = get_option( 'bonus_option_name' );
        $checked = isset($val['clear-bfw-bd']) ? "checked" : "";
        ?>
        <input name="bonus_option_name[clear-bfw-bd]" type="checkbox" value="1" <?php echo $checked; ?>>
        <small style="color:#ff0000"><?php echo __( 'Attention! This will remove all settings and all user bonus points.', 'bonus-for-woo' )?></small>
    <?php }

    ## опция28
     public static function fill_primer_field28() {
        $val = get_option( 'bonus_option_name' );
         $checked = isset($val['hystory-hide']) ? "checked" : "";
        ?>
        <input   name="bonus_option_name[hystory-hide]" type="checkbox" value="1" <?php echo $checked; ?>>
             <?php }

    ## Заполняем опцию 2
    public static function fill_primer_field2() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['title-on-account'] ?? __( 'Bonus page', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[title-on-account]" value="<?php echo esc_attr( $value ) ?>" />
      <?php }

    public static function fill_primer_field2h() {
        $val = get_option( 'bonus_option_name' );
        $title_history = $val['title-on-history-account'] ?? __( 'Points accrual', 'bonus-for-woo' );
         ?>
        <input style="width: 350px" type="text" name="bonus_option_name[title-on-history-account]" value="<?php echo esc_attr( $title_history ) ?>" />
    <?php }

    ## Заполняем опцию 4
    public static function fill_primer_field4() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['title-my-status-on-account'] ?? __( 'My status', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[title-my-status-on-account]" value="<?php echo esc_attr( $value ) ?>" />
    <?php }

    ## Заполняем опцию 5
    public static function fill_primer_field5() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['my-procent-on-account'] ?? __( 'My cashback percentage', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[my-procent-on-account]" value="<?php echo esc_attr( $value ) ?>" />
    <?php }

    ## Заполняем опцию 6
    public static function fill_primer_field6() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['my-bonus-points-on-account'] ?? __( 'My bonus points', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[my-bonus-points-on-account]" value="<?php echo esc_attr( $value ) ?>" />
    <?php }

    ## Заполняем опцию 11
    public static function fill_primer_field11() {
        $val = get_option( 'bonus_option_name' );

        $value1 = $val['remaining-amount1'] ?? __( 'Up to', 'bonus-for-woo' );
        $value2 = $val['remaining-amount2'] ?? __( 'cashback and status', 'bonus-for-woo' );
        $value3 = $val['remaining-amount3'] ?? __( ', you have to purchase goods for', 'bonus-for-woo' );
        ?>
        <input style="width: 100px" type="text" name="bonus_option_name[remaining-amount1]" value="<?php echo esc_attr( $value1 ) ?>" />
        20% <input style="width: 170px" type="text" name="bonus_option_name[remaining-amount2]" value="<?php echo esc_attr( $value2 ) ?>" /> GOLD
        <input style="width: 170px" type="text" name="bonus_option_name[remaining-amount3]" value="<?php echo esc_attr( $value3 ) ?>" /> 500 <?php echo  get_woocommerce_currency_symbol(); ?>
    <?php }

    ## Заполняем опцию 7
    public static function fill_primer_field7() {
        $val = get_option( 'bonus_option_name' );

        $value1 = $val['bonustext-in-cart1'] ?? __( 'Use', 'bonus-for-woo' );
        $value2 = $val['bonustext-in-cart2'] ?? __( 'Points to get a discount', 'bonus-for-woo' );
        $value3 = $val['bonustext-in-cart3'] ?? __( ' for this order!', 'bonus-for-woo' );
        ?>
        <input style="width: 100px" type="text" name="bonus_option_name[bonustext-in-cart1]" value="<?php echo esc_attr( $value1 ) ?>" />
    20 <input style="width: 170px" type="text" name="bonus_option_name[bonustext-in-cart2]" value="<?php echo esc_attr( $value2 ) ?>" /> 20 <?php echo  get_woocommerce_currency_symbol(); ?>
        <input style="width: 170px" type="text" name="bonus_option_name[bonustext-in-cart3]" value="<?php echo esc_attr( $value3 ) ?>" />
    <?php }

    ## Заполняем опцию 8
    public static function fill_primer_field8() {
        $val = get_option( 'bonus_option_name' );

        $value = $val['use-points-on-cart'] ?? __( 'Use points', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[use-points-on-cart]" value="<?php echo esc_attr( $value ) ?>" />
    <?php }

    ## Заполняем опцию 9
    public static function fill_primer_field9() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['bonus-points-on-cart'] ?? __( 'Bonus points', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[bonus-points-on-cart]" value="<?php echo esc_attr( $value ) ?>" />
    <?php }

## Заполняем опцию 10
    public static function fill_primer_field10() {
        $val = get_option( 'bonus_option_name' );
        $value = $val['remove-on-cart'] ?? __( 'Remove points', 'bonus-for-woo' );
        ?>
        <input style="width: 350px" type="text" name="bonus_option_name[remove-on-cart]" value="<?php echo esc_attr( $value ) ?>" />
    <?php }

## Очистка данных
	public static function sanitize_callback( $options ) {
				foreach ( $options as $name => & $val ) {
				    /* if ($name=='name_val'){
                        $val = strip_tags( $val );
                    }*/
			       if ($name){
                        $val = strip_tags( $val );
                    }
		}
		return $options;
	}


	public static function bonus_plugin_options() {
        if( current_user_can('manage_options') ) {
            $pro = get_option( 'bonus-for-woo-pro' ); if($pro == 'active'){
                $pro_text = ' Pro';
            }else{$pro_text = '';}
            ?>
            <div class="wrap bonus-for-woo-admin">

            <h2><?php echo _e('Bonus for Woo', 'bonus-for-woo'), $pro_text,' V', BONUS_COMPUTY_VERSION; ?></h2>
            <p><?php echo __('With the support of', 'bonus-for-woo'); ?> <a href="https://computy.ru" target="_blank"
                                                                            title="Разработка и поддержка сайтов на WordPress">
                    computy </a> <br>
                <a class="give_me_your_money" href="https://sobe.ru/na/kompyuti_na_podderzhku_plagina_computy_for_plugin_support"
                   target="_blank"><?php echo __('Donate to support the plugin', 'bonus-for-woo'); ?></a><br>
                <a href="https://computy.ru/blog/bonus-for-woo-wordpress/"
                   target="_blank"><?php echo __('About plugin', 'bonus-for-woo'); ?></a><br>
                <a href="https://profiles.wordpress.org/calliko/#content-plugins"
                   target="_blank"><?php echo __('Our other plugins', 'bonus-for-woo'); ?></a>
            </p>
            <hr>
            <p><?php echo __('This plugin is designed to create a bonus system with cashback.', 'bonus-for-woo'); ?><br>
                <?php echo __('The cashback percentage is calculated based on the users status in the form of bonus points.', 'bonus-for-woo'); ?>
                <br>
                <?php echo __('Each user status has a corresponding cashback percentage.', 'bonus-for-woo'); ?>
                <br>
                <?php echo __('The users status depends on the total amount of the users orders.', 'bonus-for-woo'); ?>
                <br>
                <?php echo __('You can add points to your customers on the page  <a href="users.php" target="_blank">users</a>,by selecting the desired client.', 'bonus-for-woo'); ?>
            </p>
                <a class="pdf-button" href="https://computy.ru/includes/wp_plugins/bonus-for-woo-insruction.pdf" target="_blank">PDF Инструкция</a>
            <hr>
            <h3><?php echo __('Shordcodes', 'bonus-for-woo'); ?></h3>
            <p><?php echo __('You can place the client status anywhere in the site using a shortcode:  [bfw_status]', 'bonus-for-woo'); ?>
                <br>
                <?php echo __('To display the percentage of cachek, use a shortcode: [bfw_cashback]', 'bonus-for-woo'); ?>
                <br>
                <?php echo __('To display the number of points awarded, use the shortcode: [bfw_points]', 'bonus-for-woo'); ?>
                <br>
                <?php echo __('To display the possible amount of cashback in a single product, use the shortcode: [bfw_cashback_in_product]', 'bonus-for-woo'); ?>
            </p>
            <hr>

            <div class="wrap">
            <?php


            /*Обработчик запроса добавления роли*/
            if (isset($_POST['bfw_computy_ajax'])) {
                if ($_POST['bfw_computy_ajax'] == 'bfw_computy_ajax') {
                    global $wpdb;
                    $name_role = _sanitize_text_fields($_POST['name_role']);
                    $percent_role = _sanitize_text_fields($_POST['percent_role']);
                    $summa_start = _sanitize_text_fields($_POST['summa_start']);
                    $s = $name_role;
                    $s = (string)$s; // преобразуем в строковое значение
                    $s = strip_tags($s); // убираем HTML-теги
                    $s = str_replace(array("\n", "\r"), " ", $s); // убираем перевод каретки
                    $s = preg_replace("/\s+/", ' ', $s); // удаляем повторяющие пробелы
                    $s = trim($s); // убираем пробелы в начале и конце строки
                    $s = function_exists('mb_strtolower') ? mb_strtolower($s) : strtolower($s); // переводим строку в нижний регистр (иногда надо задать локаль)
                    $s = str_replace(" ", "-", $s); // заменяем пробелы знаком _

                    if (preg_match("/[А-Яа-я]/", $s)) {
                        /*переводим в английский русские слова*/
                        $s = strtr($s, array('а' => 'a', 'б' => 'b', 'в' => 'v', 'г' => 'g', 'д' => 'd', 'е' => 'e', 'ё' => 'e', 'ж' => 'j', 'з' => 'z', 'и' => 'i', 'й' => 'y', 'к' => 'k', 'л' => 'l', 'м' => 'm', 'н' => 'n', 'о' => 'o', 'п' => 'p', 'р' => 'r', 'с' => 's', 'т' => 't', 'у' => 'u', 'ф' => 'f', 'х' => 'h', 'ц' => 'c', 'ч' => 'ch', 'ш' => 'sh', 'щ' => 'shch', 'ы' => 'y', 'э' => 'e', 'ю' => 'yu', 'я' => 'ya', 'ъ' => '', 'ь' => ''));
                    }
                    $slug = $s;
                    // подготавливаем данные
                    $table_name = $wpdb->prefix . 'bfw_computy';

                    //проверка полей

                    if ($wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "bfw_computy  WHERE `name` =  '$name_role'  ")) {
                        echo '<div id="message" class="notice notice-warning is-dismissible">
	<p>Статус <b>' . $name_role . '</b> уже используется. Введите другое имя статуса.</p>
</div>';
                        $propusk = 'no';
                    } elseif ($wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "bfw_computy  WHERE `summa_start` =  '$summa_start'  ")) {

                        $table_bfw = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "bfw_computy  WHERE `summa_start` =  '$summa_start'");
                        foreach ($table_bfw as $bfw) {
                            $isp_role = $bfw->name;
                        }
                        $propusk = 'no';

                        echo '<div id="message" class="notice notice-warning is-dismissible">
	<p>' . __('Amount', 'bonus-for-woo') . '  ' . $summa_start . ' ' . __('already used for role', 'bonus-for-woo') . ' <b>' . $isp_role . '</b>. ' . __('Enter another cumulative amount to create a status.', 'bonus-for-woo') . '</p></div>';
                    } else {
                        $propusk = 'yes';
                    }
                    //добовляем статус пользователя
                    if ($propusk == 'yes') {
                        if ($summa_start < '0') {
                            echo '<div id="message" class="notice notice-warning is-dismissible"><p>' . __('Накопленная сумма не может быть меньше 0.', 'bonus-for-woo') . '</p></div>';
                        } elseif ($name_role == '' || $slug == '') {
                            echo '<div id="message" class="notice notice-warning is-dismissible"><p>' . __('The status name cannot be empty.', 'bonus-for-woo') . '</p></div>';
                        } else {

                            $wpdb->insert(
                                $table_name, array(
                                'name' => $name_role,
                                'slug' => $slug,
                                'percent' => $percent_role,
                                'summa_start' => $summa_start,
                            ), array("%s", "%s", "%s", "%s")
                            );

                            $author = get_role('customer');
                            add_role($slug, $name_role, $author->capabilities);


                            echo '<div id="message" class="notice notice-warning is-dismissible">
	<p>' . __('Status', 'bonus-for-woo') . ' <b>' . $name_role . '</b> ' . __('added', 'bonus-for-woo') . '.</p>
</div>';
                        }
                    }
                } elseif ($_POST['bfw_computy_ajax'] == 'editrolehidden') {
                    global $wpdb;
                    $percent_role = sanitize_text_field($_POST['percent_role']);
                    $summa_start = sanitize_text_field($_POST['summa_start']);
                    $name_role = sanitize_text_field($_POST['name_role']);
                    $wpdb->update($wpdb->prefix . "bfw_computy",
                        array('percent' => $percent_role, 'summa_start' => $summa_start),
                        array('name' => $name_role)
                    );
                }
            }
            /*Обработчик запроса добавления роли*/


            /*Обработчик запроса удаления роли*/
            if (isset($_POST['delete_role'])) {
                $delete_role_slag = sanitize_text_field($_POST['delete_role_slag']);
                $delete_role_name = sanitize_text_field($_POST['delete_role_name']);
                global $wpdb;
                $table_name = $wpdb->prefix . 'bfw_computy';
                $wpdb->query($wpdb->prepare("DELETE FROM $table_name WHERE id = %d",
                    $_POST['delete_role'])
                );
                remove_role($delete_role_slag);
                echo '<div id="message" class="notice notice-warning is-dismissible">
	<p>' . __('Status', 'bonus-for-woo') . ' <b>' . $delete_role_name . '</b> ' . __('deleted', 'bonus-for-woo') . '.</p>
</div>';
            }
            /*Обработчик запроса удаления роли*/


            ?>




            <div class="tabs_bfw">
                <input type="radio" name="odin" checked="checked" id="vkl1"/><label  for="vkl1"><i class="statusicon"></i><?php echo __('Client status management', 'bonus-for-woo'); ?></label>
                <input type="radio" name="odin" id="vkl2"/><label for="vkl2"><i class="settingsicon"></i><?php echo __('Plugin settings', 'bonus-for-woo'); ?></label>
                <input type="radio" name="odin" id="vkl3"/><label for="vkl3"><i class="notifiicon"></i><?php echo __('Email notifications', 'bonus-for-woo'); ?></label>
                <input type="radio" name="odin" id="vkl4"/><label for="vkl4"><i class="transicon"></i><?php echo __('Translate', 'bonus-for-woo'); ?></label>
                <input type="radio" name="odin" id="vkl6"/><label for="vkl6"><i class="exporticon"></i><?php echo __('Export/Import', 'bonus-for-woo'); ?></label>
                <input type="radio" name="odin" id="vkl5"/><label class="nf0" for="vkl5"><?php echo __('Pro', 'bonus-for-woo'); ?></label>
               
                <div class="tab_bfw tab_bfw1"><h2><?php echo __('Client status management', 'bonus-for-woo'); ?></h2>
                    <h3><b><?php echo __('Terms:', 'bonus-for-woo'); ?></b></h3>
                    <p><?php echo __('Terms: <b>Status name</b> - the name that will be displayed in the client\'s account and his personal account.', 'bonus-for-woo'); ?></p>
                    <p><?php echo __('<b> Slug </b> is a unique name for the system to work.', 'bonus-for-woo'); ?></p>
                    <p><?php echo __('<b> Cashback percentage </b> - the percentage that will be credited to a client with the corresponding status.', 'bonus-for-woo'); ?></p>
                    <p><?php echo __('<b> Amount of orders </b> is a number corresponding to the amount of customer orders with which this role is applied to the user.
              For example, if you enter 3000, this status will change only when the sum of all customer orders exceeds 3000. </p>', 'bonus-for-woo'); ?>
                        <?php
                        global $wpdb;

                        $table_bfw = $wpdb->get_results("SELECT *,summa_start FROM " . $wpdb->prefix . "bfw_computy  ORDER BY summa_start + 0 asc");
                        if ($table_bfw) {
                            echo " 
          <div class='table-content-bfw'> <table class='table-bfw' ><thead><tr>
                  <td>" . __('Status name', 'bonus-for-woo') . "</td>
                  <td>" . __('Role slug (automatic)', 'bonus-for-woo') . "</td>
                  <td>" . __('Cashback percentage', 'bonus-for-woo') . "</td>
                  <td>" . __('Amount of orders', 'bonus-for-woo') . "</td>
                  <td>" . __('Action', 'bonus-for-woo') . "</td>
              </tr> </thead><tbody>
    ";

                            foreach ($table_bfw as $bfw) {
                                echo '<tr><td  >' . $bfw->name . '</td><td>' . $bfw->slug . '</td><td>' . $bfw->percent . '</td><td>' . $bfw->summa_start . '</td>
                  <td><input  class="pencil" type="button" value="' . $bfw->id . '"> 
                  <form method="post" action="" class="list_role_computy">
                  <input type="hidden" name="delete_role_summa_start" value="' . $bfw->summa_start . '" >
                  <input type="hidden" name="delete_role_percent" value="' . $bfw->percent . '" >
                  <input type="hidden" name="delete_role" value="' . $bfw->id . '" >
                  <input type="hidden" name="delete_role_slag" value="' . $bfw->slug . '" >
                  <input type="hidden" name="delete_role_name" value="' . $bfw->name . '" >
                  <input type="submit" value="+" class="delete_role-bfw" title="' . __('Delete status', 'bonus-for-woo') . '" onclick="return window.confirm(\' ' . __('Are you sure you want to delete the status?', 'bonus-for-woo') . ' \');">
                  </form></td></tr>';
                            }
                            echo '</tbody></table></div>';

                        } else {
                            echo '<h3>' . __('To get started with the bonus system with cashback, create a new status for customers.', 'bonus-for-woo') . '</h3>';
                        }
                        ?>
                        <form method="post" action="" id="add_role_form">
                            <input type="hidden" id="bfw_computy_ajax" name="bfw_computy_ajax" value="bfw_computy_ajax">
                            <table class="form-table" role="presentation">
                                <tbody>
                                <tr>
                                    <th scope="row"
                                        id="text_new_status"><?php echo __('New status for clients', 'bonus-for-woo'); ?></th>
                                    <td class="table-bfw">
                                        <input type="text" id="add_role_form_name_role" name="name_role" value=""
                                               placeholder="<?php echo __('Status name', 'bonus-for-woo'); ?>">
                                        <input type="number" id="add_role_form_percent_role" name="percent_role"
                                               value="" min="0"
                                               placeholder="<?php echo __('Cashback percentage', 'bonus-for-woo'); ?>">
                                        <input type="number" id="add_role_form_summa_start" name="summa_start" value=""
                                               min="0"
                                               placeholder="<?php echo __('Amount of orders', 'bonus-for-woo'); ?>">
                                    </td>
                                </tr>

                                </tbody>
                            </table>

                    <p class="submit"><input type="submit" name="submit" id="submitaddrole"
                                             class="button button-primary"
                                             value="<?php echo __('Add satus', 'bonus-for-woo'); ?>"></p>
                    </form>


                    <script>
                        function addrole() {
                            let idrole = jQuery(this).val();
                            let rolename = jQuery(this).parent().find('input[name="delete_role_name"]').val();
                            let rolepercent = jQuery(this).parent().find('input[name="delete_role_percent"]').val();
                            let rolesumma_start = jQuery(this).parent().find('input[name="delete_role_summa_start"]').val();
                            jQuery("#add_role_form_name_role ").val(rolename).addClass('hidden')/*.prop('disabled', true)*/;
                            jQuery("#add_role_form_percent_role").val(rolepercent);
                            jQuery("#add_role_form_summa_start").val(rolesumma_start);
                            jQuery("#text_new_status").text("<?php echo __('Change status', 'bonus-for-woo');?> " + rolename);
                            jQuery("#add_role_form #submitaddrole").val("<?php echo __('Edit', 'bonus-for-woo');?>");
                            jQuery("#bfw_computy_ajax").val("editrolehidden");
                        }

                        jQuery(function () {
                            jQuery('.pencil').on('click', addrole);
                        })
                    </script>
                </div>


                <div class="tab_bfw tab_bfw2">
                    <form action="options.php" method="POST">
                        <?php
                        settings_fields('option_group_bonus');
                        do_settings_sections('primer_page_bonus');
                        submit_button();
                        ?>
                </div>
                <div class="tab_bfw tab_bfw3">
                    <?php
                    settings_fields('option_mail_group_bonus');
                    do_settings_sections('mail_page_bonus');
                    submit_button();
                    ?>
                </div>
                <div class="tab_bfw tab_bfw4">
                    <?php
                    settings_fields('option_trans_group_bonus');
                    do_settings_sections('trans_page_bonus');

                    ?>
                    <?php submit_button(); ?>
                    </form>
                </div>

                <div class="tab_bfw tab_bfw6">
                    <h2><?php echo __('Export/Import', 'bonus-for-woo'); ?></h2>
                    <?php  $filename = BONUS_COMPUTY_PLUGIN_DIR . '/file.csv';
                    // echo 'При нажатии кнопки "Создать CSV файл экспорта", рядом появиться ссылка для скачивания файла.';
                    echo '<p>'.__('When you click the "Create CSV export file" button, a link to download the file will appear next to it. You can download the file and edit it and then import it in the form below. After that, the bonus points data will be updated.', 'bonus-for-woo').'</p><br>';
                   if (file_exists($filename)) {
                       echo '<a class="button button-primary" href="?page=bonus_for_woo-plugin-options&export_bfw_points=true">'.__('Recreate CSV export file', 'bonus-for-woo').'</a> ';

                       echo ' <a href="'.BONUS_COMPUTY_PLUGIN_URL.'file.csv" download>'.__('download CSV file', 'bonus-for-woo').'</a>';
                    }else{
                        echo '<a class="button button-primary" href="?page=bonus_for_woo-plugin-options&export_bfw_points=true">'.__('Сreate CSV export file', 'bonus-for-woo').'</a> ';

                    }

                    echo '<br><br><br>';
                    echo '<form action="' . admin_url("admin-post.php") . '" class="bfw_export_bonuses"  method="post"  enctype="multipart/form-data">
                        <input type="hidden" name="action" value="bfw_export_bonuses" />
                        <lable for="bfw-file-export">'.__('Upload CSV file', 'bonus-for-woo').'<br></lable>
                        <input name="file" type="file" id="bfw-file-export" required>';
                    echo'<input class="button button-primary" type="submit" value="'.__('import', 'bonus-for-woo').'" onclick="upload();return false;">
                        <div id="bfw-file-export-result"></div>
                    </form>';
                    ?>
                    <script type="text/javascript">
                        function upload(){
                            let fileExtension = ['csv'];
                            if (jQuery.inArray(jQuery('#bfw-file-export').val().split('.').pop().toLowerCase(), fileExtension) == -1) {
                                jQuery('#bfw-file-export-result').html('<span style="color:red"><?php echo __('You can only use csv file format!', 'bonus-for-woo');?></span>');
                            }else{
                               jQuery('.bfw_export_bonuses').addClass('bfv_uplouads');
                                let formData = new FormData();
                                formData.append("action", "upload-attachment");
                                let fileInputElement = document.getElementById("bfw-file-export");
                                formData.append("async-upload", fileInputElement.files[0]);
                                formData.append("name", fileInputElement.files[0].name);
                                <?php $my_nonce = wp_create_nonce('media-form'); ?>
                                formData.append("_wpnonce", "<?php echo $my_nonce; ?>");
                                let xhr = new XMLHttpRequest();
                                xhr.onreadystatechange=function(){
                                    if (xhr.readyState==4 && xhr.status==200){
                                        //  console.log(xhr.responseText);
                                        jQuery.ajax({
                                            type: 'POST',
                                            url: "/wp-admin/admin-ajax.php",
                                            data: {
                                                action: 'bfw_export_bonuses',
                                                response:xhr.responseText
                                            },
                                            success: function (data) {
                                                if(data==='good0'){
                                                    jQuery('#bfw-file-export-result').html('<span style="color:green"><?php echo __('Export completed successfully!', 'bonus-for-woo');?></span>');
                                                    jQuery('.bfw_export_bonuses').removeClass('bfv_uplouads');
                                                    jQuery('#bfw-file-export').val('');
                                                }},
                                            error: function (error) {
                                                console.log(error);
                                            }});}}
                                xhr.open("POST","/wp-admin/async-upload.php",true);
                                xhr.send(formData);
                            }}
                    </script>
                </div>
                <div class="tab_bfw tab_bfw5">
                    <h2><?php echo __('Bonus for woo Pro', 'bonus-for-woo'); ?></h2>
                    <?php $pro = get_option( 'bonus-for-woo-pro' ); if($pro == 'active'){?>
                        <h3><?php echo __('Что дает версия Pro?', 'bonus-for-woo'); ?></h3>
                        <ul>
                            <li><?php echo __('Возможность не только добавлять бонусные баллы клиентам, но и удалять.', 'bonus-for-woo'); ?></li>
                            <li><?php echo __('Возможность настраивать процент от суммы заказа, которые можно потратить клиенту баллами.', 'bonus-for-woo'); ?></li>
                            <li><?php echo __('Возможность исключать товары и категории, которые нельзя купить за баллы.', 'bonus-for-woo'); ?></li>
                            <li><?php echo __('Возможность начислять баллы за регистрацию.', 'bonus-for-woo'); ?></li>
                            <li><?php echo __('Возможность исключать роли из бонусной системы.', 'bonus-for-woo'); ?></li>
                            <li><?php echo __('Возможность установить минимальную сумму заказа, при которой можно списывать баллы.', 'bonus-for-woo'); ?></li>
                            <li><?php echo __('Реферальная система.', 'bonus-for-woo'); ?></li>

                        </ul>
                    <?php }else{?>
                    <p><?php echo __('Активируйте версию Pro для вашего сайта сейчас и навсегда. Успейте купить дешевле, потому что с добавлением новых функций будет расти цена.', 'bonus-for-woo'); ?></p>
                        <p><?php echo __('Цена версии Pro: <del>1000</del> 750 рублей', 'bonus-for-woo'); ?></p>
                    <h3><?php echo __('Что даст версия Pro?', 'bonus-for-woo'); ?></h3>
                    <ul>
                        <li><?php echo __('Возможность не только добавлять бонусные баллы клиентам, но и удалять.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Возможность настраивать процент от суммы заказа, которые можно потратить клиенту баллами.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Возможность исключать товары и категории, которые нельзя купить за баллы.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Возможность зачислять кэшбэк на исключенные товары и категории.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Возможность начислять баллы за регистрацию.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Возможность исключать роли из бонусной системы.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Возможность установить минимальную сумму заказа, при которой можно списывать баллы.', 'bonus-for-woo'); ?></li>
                        <li><?php echo __('Реферальная система.', 'bonus-for-woo'); ?></li>
                    </ul>
                    <hr>
                    <p><?php echo __('Для покупки Bonus for Woo Pro нажмите на кнопку "Купить", в открывшимся окне введите электронную почту на которое придет ключ активации для вашего сайта и оплатите заказ следуя инструкциям.', 'bonus-for-woo'); ?></p>
                    <p style="color:#ff001d"><?php echo __('В случае проблем свяжитесь по адресу info@computy.ru'); ?>
                    <form method="POST" action="https://yoomoney.ru/quickpay/confirm.xml">
                        <input type="hidden" name="receiver" value="410011302808683">
                        <input type="hidden" name="formcomment" value="Компьюти: Bonus for woo pro">
                        <input type="hidden" name="short-dest" value="Компьюти: Bonus for woo pro">
                        <input type="hidden" name="label" value="<?php echo get_site_url(); ?>">
                        <input type="hidden" name="quickpay-form" value="shop">
                        <input type="hidden" name="targets" value="Покупка плагина WordPress">
                        <input type="hidden" name="sum" value="750" data-type="number">
                        <input type="hidden" name="comment" value="Bonus for woo pro">
                        <input type="hidden" name="need-fio" value="false">
                        <input type="hidden" name="need-email" value="true">
                        <input type="hidden" name="need-phone" value="false">
                        <input type="hidden" name="need-address" value="false">
                        <input type="hidden" name="successURL"
                               value="<?php echo get_site_url() . $_SERVER['REQUEST_URI']; ?>">
                        <input type="hidden" name="paymentType" value="AC">
                        <input class="buy_pro_button" type="submit" value="Купить">
                    </form>


                    <p><?php echo __('Введите ключ активации отправленный на вашу электронную почту.', 'bonus-for-woo'); ?></p>
                    <form method="post" action="">
                        <input style="width: 250px" type="text" name="bonus-for-woo-pro" value=""/>
                        <input type="submit" value="Активировать">
                    </form>
                <?php  } ?>

                    <?php /*Обработчик активации версии Pro*/
                    if (isset($_POST['bonus-for-woo-pro'])) {
                        $key = $_POST['bonus-for-woo-pro'];
                        $site = get_site_url();
                        $arrContextOptions=array(
                            "ssl"=>array(
                                "verify_peer"=>false,
                                "verify_peer_name"=>false,
                            ),
                        );
                        $resp = file_get_contents('http://computy.ru/API/api.php?key='.$key.'&site='.$site, false, stream_context_create($arrContextOptions));

                        $data = json_decode($resp, true);
                        if($data['status']=='OK'){
                            if($data['response']){
                                update_option( 'bonus-for-woo-pro', 'active' );
                                                 }else{
                                echo '<div class="notice notice-error is-dismissible">'.__('The key is not correct! Contact info@computy.ru', 'bonus-for-woo').'</div>';
                            }
                        }else{
                            echo 'Код ошибки: '.$data['error'];
                        }
                    }
                    /*Обработчик активации версии Pro*/
                    ?>

                </div>


            </div>



      </div>
        </div>
			<?php
		}
    }
}