<?php
/**
 * Удаление баллов за бездействие
 * @version 3.0.0
 *
 */


/*находим старых клиентов*/
add_action( 'bfw_clear_old_cashback', 'delete_balls_old_clients', 10, 3 );
 function delete_balls_old_clients(){

    $val = get_option('bonus_option_name');

    $day_day = $val['day-inactive'];//количество дней которое дается клиентам на трату баллов

    $exclude_role = $val['exclude-role'] ?? '';

    $args=array(
        'role__not_in' => $exclude_role,/*исключенные роли*/
        'meta_query' => array(
            array(/*где баллы больше 0*/
                'key' => 'computy_point',
                'value' => 0,
                'compare' => '>'
            )),
    );
    $users = get_users( $args );

    foreach ($users as $user) {

        if (!class_exists('WooCommerce')) {
            require ABSPATH . 'wp-content/plugins/woocommerce/woocommerce.php';
        }



        $customer_orders = get_posts( array(/*находим все заказы клиента*/
            'posts_per_page' => -1,
            'meta_key'    => '_customer_user',
            'order' => 'ASC',
            'meta_value'  => $user->ID ,
            'post_type' => wc_get_order_types('view-orders'),
            'post_status' => array_keys(wc_get_order_statuses())
        ) );

        if(count($customer_orders)==0){/*Если заказов 0*/

            // сегодняшняя дата
            $today = strtotime(date("d.m.Y"));

            //дата регистрации клиента
            $registered = $user->user_registered;
            $registered = strtotime(date( "d.m.Y", strtotime( $registered ) ));

            $seconds = abs($today - $registered);
            $days = floor($seconds / 86400);//количество дней регистрации

            if($days>$day_day){

                //узнаем баллы клиента
                $computy_point_old = (new BfwPoints)->getPoints($user->ID);

                /*запись в историю*/
                (new BfwHistory)->add_history($user->ID,'-',$computy_point_old,'',sprintf( __( 'Inactivity %d days', 'bonus-for-woo' ), $day_day ));

                //очищаем баллы клиенту
                (new BfwPoints)->updatePoints($user->ID,0);

            }




        }
        else{
            foreach ( $customer_orders as $customer_order ) {
                if (!next($customer_orders)) {
                    // делаем что-либо с последним элементом.
                    $orderq = wc_get_order($customer_order);
                    $order_id = $orderq->get_id();
                    $data = $orderq->get_data();

                    //сегодняшняя дата
                    $today = strtotime(date("d.m.Y"));

                    //находим дату последнего заказа
                    $lastorderday = strtotime( $data['date_created']->date('d.m.Y'));
                    $seconds = abs($today - $lastorderday);
                    $days = floor($seconds / 86400);//количество дней регистрации

                    if($days>$day_day){

                        //узнаем баллы клиента
                        $computy_point_old = (new BfwPoints)->getPoints($user->ID);


                        /*запись в историю*/
                        (new BfwHistory)->add_history($user->ID,'-',$computy_point_old,'',sprintf( __( 'Inactivity %d days', 'bonus-for-woo' ), $day_day ));

                        //очищаем баллы клиенту
                        (new BfwPoints)->updatePoints($user->ID,0);

                    }
                }


            }
        }
    }

}
/*находим старых клиентов*/



$val = get_option('bonus_option_name');
if(!empty($val['day-inactive'])){


if($val['day-inactive'] != '' || $val['day-inactive'] > 0){

    if( !wp_next_scheduled('bfw_clear_old_cashback') ){

        /*запись в крон (Ппроверка каждую неделю)*/
         wp_schedule_event( time(), 'weekly', 'bfw_clear_old_cashback');

    }
}else{
    /*убрать крон*/
    wp_clear_scheduled_hook( 'bfw_clear_old_cashback' );
}

}else{
    /*убрать крон*/
    wp_clear_scheduled_hook( 'bfw_clear_old_cashback' );
}
