<?php

/**
 * Действие когда статус заказа выполнен
 * @version 3.1.0
 *
 */

/*другие статусы
woocommerce_order_status_pending
woocommerce_order_status_failed
woocommerce_order_status_on-hold
woocommerce_order_status_processing
woocommerce_order_status_completed
woocommerce_order_status_refunded
woocommerce_order_status_cancelled
*/
add_action('woocommerce_order_status_completed', 'add_computy_points', 10, 1);
function add_computy_points($order_id)
{

    /*вызов инфы о  заказе*/
$order = wc_get_order($order_id);


    /*узнаем id покупателя*/
$customer_user = $order->get_customer_id();

    if($customer_user!=0){ /*Проверяем зарегистрирован ли клиент*/



    /*сумма покупок данного заказа*/
$total = (float)$order->get_total();

/*---------Находим товары и категории, которые надо исключить---------*/
$pro = get_option('bonus-for-woo-pro');
if ($pro == 'active') {

$order_items = $order->get_items();
 $dataw = $order->get_data();
$val = get_option('bonus_option_name');


    if (!empty($val['cashback-for-shipping'])){
        /*убираем сумму доставки с кэшбэка*/
            $total = $total - $dataw['shipping_total'];

    }



$addcashbckexclude = $val['addkeshback-exclude'] ?? 0;

if ($addcashbckexclude != '1') {

$categoriexs = $val['exclude-category-cashback'] ?? 'not';

$exclude_tovar = $val['exclude-tovar-cashback'];
$tovars = explode(",", $exclude_tovar);


foreach ($order_items as $item_id => $item) {

$product_id = $item->get_product_id();
$item_data = $item->get_data();



if (in_array($product_id, $tovars)) {
if (has_term($categoriexs, 'product_cat', $product_id)) {
} else {
$sum_exclud_tov = $item_data['subtotal'];
$total = $total - $sum_exclud_tov;
}
}

if (has_term($categoriexs, 'product_cat', $product_id)) {
$sum_exclud_cat = $item_data['subtotal'];
$total = $total - $sum_exclud_cat;
}
}
}


}/*pro*/
/*---------Находим товары и категории, которые надо исключить---------*/

    /*узнаем баллы клиента*/
$computy_point_old = (new BfwPoints)->getPoints($customer_user);

   if((new BfwRoles)->is_invalve($customer_user)){/*Если участвует в бонусной системе*/

        /*минимальная сумма заказа*/
        if ($pro == 'active'){
            if(isset($val['minimal-amount'])){
                if($total<$val['minimal-amount']){
                    if(!empty($val['minimal-amount-cashback'])){
                       return false;
                    }

                }}
        }
        /*минимальная сумма заказа*/


        (new BfwRoles)->updateRole($customer_user); //обновляем роль
        $percent = (new BfwRoles)->getRole($customer_user)['percent'];//находим процент
//меняем роль пользователю

        /*-----добавляем бонусные баллы на счет клиента-----*/

        /*узнаем баллы которые решил списать клиент*/
        $computy_point_fast = (new BfwPoints)->getFastPoints($customer_user);

        $computy_point_new = ($total - $computy_point_fast) * ($percent / 100);
        $computy_point_new = round((int)$computy_point_new );
        $cout_point = $computy_point_old +  $computy_point_new;
        $cout_point = round((int)$cout_point);//округляем до целого числа


        if ($computy_point_fast > 0) {
            $cout_point = $cout_point - $computy_point_fast;
        }
        /*запись в историю*/
        $pricina = __('Points accrual', 'bonus-for-woo');
        (new BfwHistory)->add_history($customer_user,'+',$computy_point_new,$order_id,$pricina);

        /*email*/
        $val = get_option( 'bonus_option_name' );
        $text_email = $val['email-when-order-change-text'] ?? '';
        /*шаблонизатор письма*/
        $title_email = $val['email-when-order-change-title'] ?? __('Points accrual', 'bonus-for-woo');
        $user = get_userdata($customer_user);
        $get_referral = get_user_meta($customer_user, 'bfw_points_referral', true );
        $text_email_array = array('[user]'=>$user->display_name,'[order]'=>$order_id,'[points]'=>$computy_point_new,'[total]'=>$cout_point, '[referral-link]'=> esc_url(site_url().'?bfwkey='. $get_referral));
        $message_email = (new BfwEmail)->template($text_email,$text_email_array);
        /*шаблонизатор письма*/


        if(!empty($val['email-when-order-change'])){
                (new BfwEmail)->getMail($customer_user, '', $title_email, $message_email);
            }
        /*email*/

        (new BfwPoints)->updatePoints($customer_user,$cout_point);//добавляем баллы клиенту
        (new BfwPoints)->updateFastPoints($customer_user,0);//очищаем добавленную скидку


        $referalwork = isset( $val['referal-system'] ) ? intval( $val['referal-system'] ) : 0;
        /*если включена реферальная система*/
        if($referalwork) {

            //узнать если у пользователя инвайт
            $get_referral_invite = get_user_meta($customer_user, 'bfw_points_referral_invite', true);
            $get_referral_invite = (int)$get_referral_invite;
            if ($get_referral_invite != 0) {

                $percent_for_referal = $val['referal-cashback'];
                $referal_point_new = ($total - $computy_point_fast) * ($percent_for_referal / 100);
                $referal_point_new = round((int)$referal_point_new);
                /*узнаем баллы реферала*/
                $old_point_referal = (new BfwPoints)->getPoints($get_referral_invite);

                $referal_points = $old_point_referal + $referal_point_new;
                if((int)$referal_points!=0){
                $pricinaref = __('Points for referral', 'bonus-for-woo');


                /*шаблонизатор письма*/

                $text_email = $val['email-when-order-change-referal-text'] ?? '';

                $title_email = $val['email-when-order-change-referal-title'] ?? __('Points accrual', 'bonus-for-woo');
                $user = get_userdata($get_referral_invite);
                $get_referral = get_user_meta($get_referral_invite, 'bfw_points_referral', true);
                $text_email_array = array(
                    '[referral-link]' => esc_url(site_url() . '?bfwkey=' . $get_referral),
                    '[user]' => $user->display_name,
                    '[cause]' => $pricinaref,
                    '[points]' => $referal_point_new,
                    '[total]' => $referal_points
                );
                $message_email = (new BfwEmail)->template($text_email, $text_email_array);
                /*шаблонизатор письма*/


                //если гаочка стоит только первый заказ, то проверка является ли заказ первым
                $first = isset($val['first-order-referal']) ? intval($val['first-order-referal']) : 0;
                if ($first == 1) {
                    //проверка является ли заказ первым
                    $numorders = wc_get_customer_order_count($customer_user);
                    if ($numorders == 0) {
                        (new BfwHistory)->add_history($get_referral_invite, '+', $referal_point_new, '0', $pricinaref);
                        $val = get_option('bonus_option_name');
                        if (!empty($val['email-when-order-change'])) {
                            (new BfwEmail)->getMail($get_referral_invite, '', $title_email, $message_email);
                        }
                        /*email*/
                        (new BfwPoints)->updatePoints($get_referral_invite, $referal_points); //добавляем баллы инвайту
                    }
                } else {

                    (new BfwHistory)->add_history($get_referral_invite, '+', $referal_point_new, '0', $pricinaref);
                    /*email*/
                    $val = get_option('bonus_option_name');
                    if (!empty($val['email-when-order-change'])) {
                        (new BfwEmail)->getMail($get_referral_invite, '', $title_email, $message_email);
                    }
                    /*начислить баллы инвайту*/
                    (new BfwPoints)->updatePoints($get_referral_invite, $referal_points); //добавляем баллы инвайту

                }
            }
        }


        }

    }
    }


}

/*------------Действие когда оформлен возврат------------*/
add_action('woocommerce_order_status_refunded', 'refunded_computy_points', 10, 1);
function refunded_computy_points($order_id){
    $order = wc_get_order($order_id);

    /*узнаем id покупателя*/
    $customer_user = $order->get_customer_id();
    /*узнаем баллы клиента*/
    $computy_point_old = (new BfwPoints)->getPoints($customer_user);


    $fee_total=0;
// Iterating through order fee items ONLY
    foreach( $order->get_items('fee') as $item_id => $item_fee ){
        // The fee name
        $val = get_option( 'bonus_option_name' );

        if( $item_fee->get_name()== $val['bonus-points-on-cart']){
            $fee_total = $item_fee->get_total();

        }

    }
    if($fee_total<0){
        $fee_total=$fee_total*-1;
    }
    $cout_point = $computy_point_old+$fee_total;

    /*запись в историю*/
    $pricina = __('Refund of bonus points', 'bonus-for-woo');

    global $wpdb;
    $getplusball = $wpdb->get_var('SELECT points FROM ' . $wpdb->prefix . 'bfw_history_computy WHERE user = "' . $customer_user . '" AND symbol="+" AND orderz = "' .$order_id . '" ');
    $info_email = '';
    $getplusball = round((int)$getplusball);
    if($getplusball>0){
       /*убираем заработанные баллы*/
        (new BfwHistory)->add_history($customer_user,'-',$getplusball,$order_id,$pricina);
       $cout_point = $cout_point-$getplusball;
        $info_email .= sprintf(__(' The %s bonus points you earned for order no. %s have been canceled.', 'bonus-for-woo'), $getplusball,$order_id);
   }

   if($fee_total>0){
       /*добавляем списанные баллы*/
       (new BfwHistory)->add_history($customer_user,'+',$fee_total,$order_id,$pricina);
       $info_email .= sprintf(__(' You have returned %s bonus points for order number %s.', 'bonus-for-woo'), $fee_total,$order_id);
   }
    (new BfwPoints)->updatePoints($customer_user,$cout_point);//обновляем баллы клиенту
    (new BfwRoles)->updateRole($customer_user); //обновляем роль клиенту
    /*email*/
    $val = get_option( 'bonus_option_name' );



    /*шаблонизатор письма*/
    $title_email = $val['email-when-order-change-title-vozvrat'] ?? __('Refund of bonus points', 'bonus-for-woo');
    $text_email = $val['email-when-order-change-text-vozvrat'] ?? '';

    $user = get_userdata($customer_user);
    $get_referral = get_user_meta($customer_user, 'bfw_points_referral', true );
    $text_email_array = array('[referral-link]'=> esc_url(site_url().'?bfwkey='. $get_referral),'[user]'=>$user->display_name,'[cashback]'=>$getplusball,'[order]'=>$order_id,'[points]'=>$fee_total,'[total]'=>$cout_point);
    $message_email = (new BfwEmail)->template($text_email,$text_email_array);
    /*шаблонизатор письма*/


    if(isset($val['email-when-order-change'])){
        if($val['email-when-order-change']=='1') {
            if($getplusball>0 OR $fee_total>0){
                (new BfwEmail)->getMail($customer_user, '', $title_email, $message_email);
            }
        }}
    /*email*/
}